Index: branches/0.2-poznan-univ/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/0.2-poznan-univ/source/App/TAppEncoder/TAppEncTop.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/App/TAppEncoder/TAppEncTop.cpp	(revision 12)
@@ -141,4 +141,8 @@
     m_acTEncTopList[iViewIdx]->setUseFastEnc                   ( m_bUseFastEnc  );
 
+#if POZNAN_NONLINEAR_DEPTH
+    m_acTEncTopList[iViewIdx]->setDepthPower                   ( (Float)m_fDepthPower );
+#endif
+
 #if HHI_VSO
     m_acTEncTopList[iViewIdx]->setUseVSO                       ( false ); //GT: might be enabled later for VSO Mode 4
@@ -222,4 +226,11 @@
     m_acTEncTopList[iViewIdx]->setQpChangeOffsetVideo( m_iQpChangeOffsetVideo );
     m_acTEncTopList[iViewIdx]->setQpChangeOffsetDepth( m_iQpChangeOffsetDepth );
+
+    
+ #if POZNAN_TEXTURE_TU_DELTA_QP_PARAM_IN_CFG_FOR_ENC
+    m_acTEncTopList[iViewIdx]->setTextureCuDeltaQpOffset( m_dTextureCuDeltaQpOffset );
+    m_acTEncTopList[iViewIdx]->setTextureCuDeltaQpMul( m_dTextureCuDeltaQpMul );
+    m_acTEncTopList[iViewIdx]->setTextureCuDeltaQpTopBottomRow( m_iTextureCuDeltaQpTopBottomRow );  
+#endif
   }
   if( m_bUsingDepthMaps )
@@ -382,4 +393,7 @@
       m_acTEncDepthTopList[iViewIdx]->setUseMVI( m_bUseMVI );
 #endif
+#if POZNAN_NONLINEAR_DEPTH
+      m_acTEncDepthTopList[iViewIdx]->setDepthPower                   ( (Float)m_fDepthPower );
+#endif
 
       m_acTEncDepthTopList[iViewIdx]->setPictureDigestEnabled(m_pictureDigestEnabled);
@@ -435,5 +449,5 @@
 #endif
 
-#if POZNAN_SYNTH
+#if POZNAN_CU_SYNTH||POZNAN_CU_SKIP
   //m_cAvailabilityRenderer.init(m_iSourceWidth, m_iSourceHeight,true,0,0,true, 0,0,0,0,0,0,0,1,0,0 );  //GT: simplest configuration
   m_cAvailabilityRenderer.init(m_iSourceWidth, m_iSourceHeight,true,0,LOG2_DISP_PREC_LUT,true, 0,0,0,0,0,6,4,1,0,6 );  //GT: simplest configuration
@@ -443,4 +457,14 @@
   m_cUsedPelsRenderer.init(m_iSourceWidth, m_iSourceHeight, true, 0, LOG2_DISP_PREC_LUT, true, 0, 0, 0, 0, 0, 6, 4, 1, 0, 6 );
 #endif
+
+#if POZNAN_MP
+#if POZNAN_MP_USE_DEPTH_MAP_GENERATION
+  m_pcMP = new TComMP(m_iSourceHeight, m_iSourceWidth);
+#else
+  //m_pcMP = new TComMP(m_iSourceHeight, m_iSourceWidth, &m_cCameraData);
+  m_pcMP = new TComMP(m_iSourceHeight, m_iSourceWidth, m_cCameraData.getBaseViewShiftLUTI());
+#endif
+#endif
+
 }
 
@@ -484,4 +508,16 @@
   }
 #endif
+
+#if POZNAN_STAT_JK
+  for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++)
+  {
+	if(m_pchStatFileList[iViewIdx] != NULL) m_cStatFileList.push_back(fopen(m_pchStatFileList[iViewIdx],"w"));
+	else m_cStatFileList.push_back(NULL);
+
+	if ( m_bUsingDepthMaps && m_pchDepthStatFileList[iViewIdx] != NULL) m_cDepthStatFileList.push_back(fopen(m_pchDepthStatFileList[iViewIdx],"w"));
+	else m_cDepthStatFileList.push_back(NULL);
+  }
+#endif  
+
 }
 
@@ -490,4 +526,16 @@
 
   m_cTVideoIOBitsFile.closeBits();
+
+#if POZNAN_MP
+  if (m_pcMP) { delete m_pcMP; m_pcMP=NULL; };
+#endif
+
+#if POZNAN_STAT_JK
+  for ( Int iViewIdx = 0; iViewIdx < m_iNumberOfExternalRefs; iViewIdx++ )
+  {
+	  if(m_cStatFileList[iViewIdx]) {fclose(m_cStatFileList[iViewIdx]); m_cStatFileList[iViewIdx]=NULL;}
+	  if(m_cDepthStatFileList[iViewIdx]) {fclose(m_cDepthStatFileList[iViewIdx]); m_cDepthStatFileList[iViewIdx]=NULL;}
+  }
+#endif
 
 #if HHI_VSO
@@ -545,4 +593,10 @@
     m_acTEncTopList[iViewIdx]->setTEncTopList( &m_acTEncTopList  );
   }
+#if POZNAN_STAT_JK
+  for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
+  {
+    m_acTEncTopList[iViewIdx]->setStatFile(m_cStatFileList[iViewIdx]);//JK
+  }
+#endif
   if ( m_bUsingDepthMaps )
   {
@@ -555,4 +609,10 @@
       m_acTEncDepthTopList[iViewIdx]->setTEncTopList( &m_acTEncDepthTopList  );
     }
+#if POZNAN_STAT_JK
+  for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
+  {
+    m_acTEncDepthTopList[iViewIdx]->setStatFile(m_cDepthStatFileList[iViewIdx]);//JK
+  }
+#endif
   }
 }
@@ -645,4 +705,7 @@
         {
           m_acTVideoIOYuvDepthInputFileList[iViewIdx]->read( pcPdmDepthOrg, m_aiPad, m_bUsingDepthMaps );
+#if POZNAN_NONLINEAR_DEPTH
+          pcPdmDepthOrg->power(pcPdmDepthOrg, m_fDepthPower);		  
+#endif
         }
 #endif
@@ -666,4 +729,7 @@
           // read input YUV file
           m_acTVideoIOYuvDepthInputFileList[iViewIdx]->read( pcDepthPicYuvOrg, m_aiPad  ) ;
+#if POZNAN_NONLINEAR_DEPTH
+          pcDepthPicYuvOrg->power(pcDepthPicYuvOrg, m_fDepthPower);		  
+#endif
           bDepthEos[iViewIdx] = ( m_acTVideoIOYuvDepthInputFileList[iViewIdx]->isEof() == 1 ?   true : false  );
           bDepthEos[iViewIdx] = ( m_iDepthFrameRcvdVector[iViewIdx] == (m_iFrameToBeEncoded - 1) ?    true : bDepthEos[iViewIdx]   );
@@ -697,5 +763,5 @@
     for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )     // Start encoding
     {
-#if POZNAN_SYNTH
+#if POZNAN_CU_SYNTH||POZNAN_CU_SKIP
       xStoreSynthPicsInBuffer(iViewIdx,false);
 #endif
@@ -716,5 +782,5 @@
       if( m_bUsingDepthMaps )
       {
-#if POZNAN_SYNTH
+#if POZNAN_CU_SYNTH||POZNAN_CU_SKIP
         xStoreSynthPicsInBuffer(iViewIdx,true);
 #endif
@@ -939,4 +1005,16 @@
   {
     riNextPocToDump++;
+#if POZNAN_NONLINEAR_DEPTH
+    if(isDepth)
+    {
+      TComPicYuv *pcPicOrg = i->second;
+      TComPicYuv *pcPicPow = new TComPicYuv; 
+      //pcPicYuvRec->createCompatibleAs(*iterPicYuvRec);
+      pcPicPow->create( pcPicOrg->getWidth(), pcPicOrg->getHeight(), pcPicOrg->getMaxCuWidth(), pcPicOrg->getMaxCuHeight(), pcPicOrg->getMaxCuDepth() );
+      //cPicPower.create(pcSPS->getWidth(), pcSPS->getHeight(), pcSPS->getMaxCUWidth(), pcSPS->getMaxCUHeight(), pcSPS->getMaxCUDepth() ); 
+      pcPicOrg->power(pcPicPow, (Float)(1.0/m_fDepthPower));		
+      rpcTVideoIOYuvReconFile->write( pcPicPow, m_aiPad );
+    } else
+#endif
     rpcTVideoIOYuvReconFile->write( i->second, m_aiPad );
     rcMap.erase( i );
@@ -1188,6 +1266,6 @@
 #endif
 
-#if POZNAN_SYNTH
-Void TAppEncTop::xStoreSynthPicsInBuffer(Int iCoddedViewIdx,Bool bDepth)
+#if POZNAN_CU_SYNTH||POZNAN_CU_SKIP
+Void TAppEncTop::xStoreSynthPicsInBuffer(Int iCoddedViewIdx, Bool bDepth)
 {
   Int iCurPoc;
@@ -1200,7 +1278,6 @@
   {
     iCurPoc = m_acTEncTopList[ iCoddedViewIdx ]->getNextFrameId();
-    if (!(m_acTEncTopList[ iCoddedViewIdx ]->currentPocWillBeCoded())) return;
-  }
-  
+  if (!(m_acTEncTopList[ iCoddedViewIdx ]->currentPocWillBeCoded())) return;
+
   Int iNumberOfReferenceViews = 0;
   UInt iSynthViewIdx;
@@ -1221,23 +1298,30 @@
 
   m_cAvailabilityRenderer.setShiftLUTs(
-    m_cCameraData.getBaseViewShiftLUTD()[iNearestViewIdx][iCoddedViewIdx],
-    m_cCameraData.getBaseViewShiftLUTI()[iNearestViewIdx][iCoddedViewIdx],
-    m_cCameraData.getBaseViewShiftLUTI()[iNearestViewIdx][iCoddedViewIdx],
-    m_cCameraData.getBaseViewShiftLUTD()[iNearestViewIdx][iCoddedViewIdx],//right
-    m_cCameraData.getBaseViewShiftLUTI()[iNearestViewIdx][iCoddedViewIdx],
-    m_cCameraData.getBaseViewShiftLUTI()[iNearestViewIdx][iCoddedViewIdx],
-    iRelDistToLeft
-  );
-    
+        m_cCameraData.getBaseViewShiftLUTD()[iNearestViewIdx][iCoddedViewIdx],
+        m_cCameraData.getBaseViewShiftLUTI()[iNearestViewIdx][iCoddedViewIdx],
+        m_cCameraData.getBaseViewShiftLUTI()[iNearestViewIdx][iCoddedViewIdx],
+        m_cCameraData.getBaseViewShiftLUTD()[iNearestViewIdx][iCoddedViewIdx],//right
+        m_cCameraData.getBaseViewShiftLUTI()[iNearestViewIdx][iCoddedViewIdx],
+        m_cCameraData.getBaseViewShiftLUTI()[iNearestViewIdx][iCoddedViewIdx],
+        iRelDistToLeft
+      );
 
   TComPicYuv* pcPicYuvERView = new TComPicYuv;
   pcPicYuvERView->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-
   TComPic* pcPic = xGetPicFromView( iCoddedViewIdx, iCurPoc, bDepth );
   pcPic->addSynthesisBuffer();
   pcPic->addAvailabilityBuffer();
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+      pcPic->addSynthesisDepthBuffer();
+      TComPicYuv* pcPicYuvSynthDepthView = pcPic->getPicYuvSynthDepth();
+      m_cAvailabilityRenderer.extrapolateAvailabilityView( xGetPicFromView( iNearestViewIdx, iCurPoc, true )->getPicYuvRec(), xGetPicFromView( iNearestViewIdx, iCurPoc, true )->getPicYuvRec(), pcPicYuvSynthDepthView, pcPic->getPicYuvAvail(), bRenderFromLeft );
+#if POZNAN_OUTPUT_SYNTH
+      Char acFilenameBaseD[1024];
+      ::sprintf( acFilenameBaseD,  "SynthDepth_%s_V%d.yuv", ( false ? "Dec" : "Enc" ),iCoddedViewIdx );
+      pcPicYuvSynthDepthView->dump(acFilenameBaseD, iCurPoc!=0);
+#endif
+#endif
   TComPicYuv* pcPicYuvSynthView = pcPic->getPicYuvSynth();
   TComPicYuv* pcPicYuvAvailView = pcPic->getPicYuvAvail();
-  
   //m_cAvailabilityRenderer.extrapolateAvailabilityView( xGetPicFromView( iNearestViewIdx, iCurPoc, false )->getPicYuvRec(), xGetPicFromView( iNearestViewIdx, iCurPoc, true )->getPicYuvRec(), pcPicYuvERView, pcPicYuvAvailView, bRenderFromLeft );
   m_cAvailabilityRenderer.extrapolateAvailabilityView( xGetPicFromView( iNearestViewIdx, iCurPoc, bDepth )->getPicYuvRec(), xGetPicFromView( iNearestViewIdx, iCurPoc, true )->getPicYuvRec(), pcPicYuvSynthView, pcPicYuvAvailView, bRenderFromLeft );
@@ -1256,7 +1340,7 @@
 #if POZNAN_OUTPUT_AVAILABLE_MAP
   {
-  Char acFilenameBase[1024];
-  ::sprintf( acFilenameBase,  "Available_%s_%s_V%d.yuv", (bDepth?"Depth":"Tex"),( false ? "Dec" : "Enc" ),iCoddedViewIdx );
-  pcPicYuvAvailView->dump(acFilenameBase, iCurPoc!=0);
+    Char acFilenameBase[1024];
+    ::sprintf( acFilenameBase,  "Available_%s_%s_V%d.yuv", (bDepth?"Depth":"Tex"),( false ? "Dec" : "Enc" ),iCoddedViewIdx );
+    pcPicYuvAvailView->dump(acFilenameBase, iCurPoc!=0);
   }
 #endif
@@ -1268,6 +1352,4 @@
   }
 #endif
-
-      //Usun pcPicYuvERView i inne bufforki
 }
 #endif
Index: branches/0.2-poznan-univ/source/App/TAppEncoder/TAppEncTop.h
===================================================================
--- branches/0.2-poznan-univ/source/App/TAppEncoder/TAppEncTop.h	(revision 11)
+++ branches/0.2-poznan-univ/source/App/TAppEncoder/TAppEncTop.h	(revision 12)
@@ -51,4 +51,8 @@
 //GT VSO end
 
+#if POZNAN_MP
+#include "../../Lib/TLibCommon/TComMP.h"
+#endif	
+
 // ====================================================================================================================
 // Class definition
@@ -92,6 +96,15 @@
 #endif
 
-#if POZNAN_SYNTH
+#if POZNAN_CU_SKIP||POZNAN_CU_SYNTH
   TRenTop                     m_cAvailabilityRenderer;
+#endif
+
+#if POZNAN_MP
+  TComMP*				  m_pcMP;
+#endif
+
+#if POZNAN_STAT_JK
+  std::vector<FILE*>       m_cStatFileList;					    ///< texure statistics file handles
+  std::vector<FILE*>       m_cDepthStatFileList;				///< depth statistics file handles
 #endif
 
@@ -149,4 +162,8 @@
 #endif
 
+#if POZNAN_MP
+  TComMP* getMP() {return m_pcMP;}
+#endif
+
 #if HHI_VSO
 private:
@@ -160,5 +177,5 @@
 
 
-#if POZNAN_SYNTH
+#if POZNAN_CU_SYNTH
 private:
   Void  xStoreSynthPicsInBuffer(Int iCoddedViewIdx, Bool bDepth);
Index: branches/0.2-poznan-univ/source/App/TAppRenderer/TAppRendererCfg.cpp
===================================================================
--- branches/0.2-poznan-univ/source/App/TAppRenderer/TAppRendererCfg.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/App/TAppRenderer/TAppRendererCfg.cpp	(revision 12)
@@ -186,5 +186,9 @@
   {
     m_cCameraData.init( MAX_INPUT_VIEW_NUM, uiInputBitDepth, uiCamParPrecision, (UInt)m_iFrameSkip, (UInt)m_iFramesToBeRendered,
-      m_pchCameraParameterFile, m_pchBaseViewCameraNumbers, NULL, NULL, m_iLog2SamplingFactor+m_iShiftPrecision );
+      m_pchCameraParameterFile, m_pchBaseViewCameraNumbers, NULL, NULL, m_iLog2SamplingFactor+m_iShiftPrecision
+#if POZNAN_NONLINEAR_DEPTH      
+      ,1.0f 
+#endif
+      );
     m_iNumberOfInputViews  = (Int) m_cCameraData.getBaseViewNumbers() .size();
     m_iNumberOfOutputViews = m_iNumberOfInputViews - 1;
@@ -205,10 +209,18 @@
 
   m_cCameraData.init( MAX_INPUT_VIEW_NUM, uiInputBitDepth, uiCamParPrecision, (UInt)m_iFrameSkip, (UInt)m_iFramesToBeRendered,
-      m_pchCameraParameterFile, m_pchBaseViewCameraNumbers, NULL, piaTempViews, m_iLog2SamplingFactor+m_iShiftPrecision );
+      m_pchCameraParameterFile, m_pchBaseViewCameraNumbers, NULL, piaTempViews, m_iLog2SamplingFactor+m_iShiftPrecision
+#if POZNAN_NONLINEAR_DEPTH
+      , 1.0f 
+#endif
+      );
   }
   else
   {
   m_cCameraData.init( MAX_INPUT_VIEW_NUM, uiInputBitDepth, uiCamParPrecision, (UInt)m_iFrameSkip, (UInt)m_iFramesToBeRendered,
-      m_pchCameraParameterFile, m_pchBaseViewCameraNumbers, m_pchSynthViewCameraNumbers, NULL, m_iLog2SamplingFactor+m_iShiftPrecision );
+      m_pchCameraParameterFile, m_pchBaseViewCameraNumbers, m_pchSynthViewCameraNumbers, NULL, m_iLog2SamplingFactor+m_iShiftPrecision
+#if POZNAN_NONLINEAR_DEPTH
+      ,1.0f 
+#endif
+      );
   m_iNumberOfOutputViews = (Int) m_cCameraData.getSynthViewNumbers().size();
   m_iNumberOfInputViews  = (Int) m_cCameraData.getBaseViewNumbers() .size();
Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/CommonDef.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/CommonDef.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/CommonDef.h	(revision 12)
@@ -137,5 +137,5 @@
 #define LOG2_DISP_PREC_LUT   				2		  		///< log2 of disparity precision used in integer disparity LUTs
 
-#if ( HHI_INTER_VIEW_MOTION_PRED || HHI_INTER_VIEW_RESIDUAL_PRED )
+#if ( HHI_INTER_VIEW_MOTION_PRED || HHI_INTER_VIEW_RESIDUAL_PRED || POZNAN_MP_USE_DEPTH_MAP_GENERATION)
 #define DEPTH_MAP_GENERATION        1
 #else
@@ -178,4 +178,29 @@
 #define POZNAN_OUTPUT_SYNTH               0           // output synthesised view (for debugging)
 
+#if POZNAN_NONLINEAR_DEPTH
+#define POZNAN_LUT_INCREASED_PRECISION 0 // 1
+#else
+#define POZNAN_LUT_INCREASED_PRECISION 0
+#endif
+
+#if POZNAN_NONLINEAR_DEPTH
+inline UChar quantizeDepthPower(Float fDepthPower)
+{
+  Int r = (Int) ( (fDepthPower-1.0f)*128.0f + 0.5f);
+  if (r<=0) return 0;
+  if (r>255) r=255;  
+  return r;
+};
+
+inline Float dequantizeDepthPower(Int iDepthQuant)
+{
+  return iDepthQuant/128.0f + 1.0f;  
+};
+#endif
+
+#if POZNAN_EIVD
+#define POZNAN_EIVD_MERGE_POS                     0         // position of EIVD candidate in merge list for coding (0..6) - overwrites PDM_MERGE_POS settings, is overwritten by HHI_MPI_MERGE_POS settings!!!
+#endif
+
 // ====================================================================================================================
 // Macro functions
@@ -187,5 +212,13 @@
 #define Clip(x)                     ( Min(g_uiIBDI_MAX, Max( 0, (x)) ) )                              ///< clip with bit-depth range
 #define Clip3( MinVal, MaxVal, a)   ( ((a)<(MinVal)) ? (MinVal) : (((a)>(MaxVal)) ? (MaxVal) :(a)) )  ///< general min/max clip
-#define RemoveBitIncrement(x)       ( (x + ( (1 << g_uiBitIncrement) >> 1 )) >> g_uiBitIncrement )     ///< Remove Bit increment
+#define RemoveBitIncrement(x)       ( ((x) + ( (1 << g_uiBitIncrement) >> 1 )) >> g_uiBitIncrement )     ///< Remove Bit increment
+
+#if POZNAN_LUT_INCREASED_PRECISION
+#define RemoveBitIncrementLUT(x)       (x)     ///< Remove Bit increment
+#define SizeOfLUT                      (256 << g_uiBitIncrement)  
+#else
+#define SizeOfLUT                      256
+#define RemoveBitIncrementLUT(x)       ( ((x) + ( (1 << g_uiBitIncrement) >> 1 )) >> g_uiBitIncrement )     ///< Remove Bit increment
+#endif
 
 #define DATA_ALIGN                  1                                                                 ///< use 32-bit aligned malloc/free
@@ -217,5 +250,10 @@
 #define AMVP_MAX_NUM_CANDS          6           ///< max number of final candidates
 // MERGE
+#if POZNAN_EIVD
+#define MRG_MAX_NUM_CANDS           7
+#define POZNAN_EIVD_MRG_CAND	MRG_MAX_NUM_CANDS-1			// position of EIVD candidate in merge list (0..6)
+#else
 #define MRG_MAX_NUM_CANDS           6
+#endif
 
 // Reference memory management
Index: branches/0.2-poznan-univ/source/Lib/TLibCommon/ContextTables.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibCommon/ContextTables.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibCommon/ContextTables.h	(revision 12)
@@ -53,5 +53,5 @@
 #define NUM_MERGE_FLAG_EXT_CTX        3       ///< number of context models for merge flag of merge extended
 #define NUM_MERGE_IDX_EXT_CTX         4       ///< number of context models for merge index of merge extended
-#define NUM_MV_MERGE_IDX_EXT_CTX      5       ///< number of context models for merge index of merge extended
+#define NUM_MV_MERGE_IDX_EXT_CTX      6       ///< number of context models for merge index of merge extended
 #define NUM_RES_PRED_FLAG_CTX         3       ///< number of context for residual prediction flag     
 
